Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Problems/InfillProblem.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Problems/InfillProblem.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Problems/InfillProblem.cs	(revision 15064)
@@ -21,4 +21,6 @@
 
 using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,4 +29,5 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
 
 namespace HeuristicLab.Algorithms.EGO {
@@ -33,39 +36,31 @@
   public sealed class InfillProblem : SingleObjectiveBasicProblem<RealVectorEncoding> {
 
-    public override bool Maximization => true;  //This is necessary because algorithms do not expect the maximization to change
+    public override bool Maximization => true;
 
-    #region Properties;
+    #region ProblemResultNames
+    public const string BestInfillSolutionResultName = "BestInfillSolution";
+    public const string BestInfillQualityResultName = "BestInfillQuality";
+    #endregion
+
+    #region Properties
     [Storable]
     private IInfillCriterion infillCriterion;
-    [Storable]
-    private SingleObjectiveBasicProblem<IEncoding> problem;
 
     public IInfillCriterion InfillCriterion
     {
       get { return infillCriterion; }
-      set { infillCriterion = value; }
-    }
-    public SingleObjectiveBasicProblem<IEncoding> Problem
-    {
-      get { return problem; }
       set
       {
-        problem = value;
-        if (problem == null) return;
-        var enc = problem.Encoding as RealVectorEncoding;
-        if (enc == null) throw new ArgumentException("EGO can not be performed on non-RealVectorEncodings");
-        Encoding = enc;
-        SolutionCreator = new UniformRandomRealVectorCreator();//ignore Problem specific Solution Creation
-
+        infillCriterion = value;
+        infillCriterion.Encoding = Encoding;
       }
     }
     #endregion
 
-    #region HLConstructors
+    #region Constructors
     [StorableConstructor]
     private InfillProblem(bool deserializing) : base(deserializing) { }
     private InfillProblem(InfillProblem original, Cloner cloner) : base(original, cloner) {
-      infillCriterion = cloner.Clone(original.InfillCriterion);
-      problem = cloner.Clone(original.Problem);
+      infillCriterion = cloner.Clone(original.infillCriterion);
     }
     public InfillProblem() { }
@@ -74,24 +69,53 @@
 
     public override double Evaluate(Individual individual, IRandom r) {
-      var q = InfillCriterion.Evaluate(individual.RealVector());
-      return InfillCriterion.Maximization() ? q : -q;
+      return !InBounds(individual.RealVector(), Encoding.Bounds) ? double.MinValue : InfillCriterion.Evaluate(individual.RealVector());
     }
     public override void Analyze(Individual[] individuals, double[] qualities, ResultCollection results, IRandom random) {
       base.Analyze(individuals, qualities, results, random);
       var best = qualities.ArgMax(x => x);
-      var qnew = InfillCriterion.Maximization() ? qualities[best] : -qualities[best];
-      const string qname = EfficientGlobalOptimizationAlgorithm.BestInfillQualityResultName;
-      const string sname = EfficientGlobalOptimizationAlgorithm.BestInfillSolutionResultName;
-      if (!results.ContainsKey(EfficientGlobalOptimizationAlgorithm.BestInfillQualityResultName)) {
-        results.Add(new Result(sname, (RealVector)individuals[best].RealVector().Clone()));
-        results.Add(new Result(qname, new DoubleValue(qnew)));
+      var newQuality = qualities[best];
+      if (!results.ContainsKey(BestInfillQualityResultName)) {
+        results.Add(new Result(BestInfillSolutionResultName, (RealVector)individuals[best].RealVector().Clone()));
+        results.Add(new Result(BestInfillQualityResultName, new DoubleValue(newQuality)));
         return;
       }
-      var qold = results[qname].Value as DoubleValue;
+      var qold = results[BestInfillQualityResultName].Value as DoubleValue;
       if (qold == null) throw new ArgumentException("Old best quality is not a double value. Conflicting Analyzers?");
-      if (qold.Value >= qnew == InfillCriterion.Maximization()) return;
-      results[sname].Value = (RealVector)individuals[best].RealVector().Clone();
-      qold.Value = qnew;
+      if (qold.Value >= newQuality) return;
+      results[BestInfillSolutionResultName].Value = (RealVector)individuals[best].RealVector().Clone();
+      qold.Value = newQuality;
     }
+    public override IEnumerable<Individual> GetNeighbors(Individual individual, IRandom random) {
+      var bounds = Encoding.Bounds;
+      var michalewiczIteration = 0;
+      while (true) {
+        var neighbour = individual.Copy();
+        var r = neighbour.RealVector();
+        switch (random.Next(5)) {
+          case 0: UniformOnePositionManipulator.Apply(random, r, bounds); break;
+          case 1: UniformOnePositionManipulator.Apply(random, r, bounds); break;//FixedNormalAllPositionsManipulator.Apply(random, r, new RealVector(new[] { 0.1 })); break;
+          case 2: MichalewiczNonUniformAllPositionsManipulator.Apply(random, r, bounds, new IntValue(michalewiczIteration++), new IntValue(10000), new DoubleValue(5.0)); break;
+          case 3: MichalewiczNonUniformOnePositionManipulator.Apply(random, r, bounds, new IntValue(michalewiczIteration++), new IntValue(10000), new DoubleValue(5.0)); break;
+          case 4: BreederGeneticAlgorithmManipulator.Apply(random, r, bounds, new DoubleValue(0.1)); break;
+          default: throw new NotImplementedException();
+        }
+        yield return neighbour;
+        michalewiczIteration %= 10000;
+      }
+    }
+
+    public void Initialize(IRegressionSolution model, bool expensiveMaximization) {
+      infillCriterion.RegressionSolution = model;
+      infillCriterion.ExpensiveMaximization = expensiveMaximization;
+      infillCriterion.Encoding = Encoding;
+      infillCriterion.Initialize();
+    }
+
+    #region helpers
+    private static bool InBounds(RealVector r, DoubleMatrix bounds) {
+      return !r.Where((t, i) => t < bounds[i % bounds.Rows, 0] || t > bounds[i % bounds.Rows, 1]).Any();
+    }
+    #endregion
+
   }
 }
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/SamplingMethods/LatinHyperCubeDesignCreator.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/SamplingMethods/LatinHyperCubeDesignCreator.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/SamplingMethods/LatinHyperCubeDesignCreator.cs	(revision 15064)
@@ -0,0 +1,81 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+// ReSharper disable once CheckNamespace
+namespace HeuristicLab.Algorithms.EGO {
+
+  [StorableClass]
+  [Item("LatinHyperCubeDesignCreator", "A latin hypercube sampling strategy for real valued optimization")]
+  public class LatinHyperCubeDesignCreator : RealVectorCreator, IInitialSampling {
+    private IValueLookupParameter<IntValue> DesignSize => (IValueLookupParameter<IntValue>)Parameters["DesignSize"];
+    [Storable]
+    private Queue<RealVector> design = new Queue<RealVector>();
+
+    [StorableConstructor]
+    protected LatinHyperCubeDesignCreator(bool deserializing) : base(deserializing) { }
+
+    protected LatinHyperCubeDesignCreator(LatinHyperCubeDesignCreator original, Cloner cloner) : base(original, cloner) {
+      design = new Queue<RealVector>(original.design.Select(cloner.Clone));
+    }
+    public LatinHyperCubeDesignCreator() {
+      Parameters.Add(new ValueLookupParameter<IntValue>("DesignSize", "The size of the LHS-design produced by this creator"));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LatinHyperCubeDesignCreator(this, cloner);
+    }
+
+    public RealVector[] GetSamples(int noSamples, RealVector[] existingSamples, RealVectorEncoding encoding, IRandom random) {
+      return GetSamples(random, encoding.Length, encoding.Bounds, noSamples);
+    }
+
+    public RealVector[] GetSamples(IRandom random, int dimensions, DoubleMatrix bounds, int noSamples) {
+      if (noSamples < 1) throw new ArgumentException("Designs need to have at least 1 Point");
+      var samples = new RealVector[noSamples];
+      for (var i = 0; i < noSamples; i++) samples[i] = new RealVector(dimensions);
+
+      for (var i = 0; i < dimensions; i++) {
+        var permutations = new Permutation(PermutationTypes.Absolute, noSamples, random);
+        var row = i % bounds.Rows;
+        var offset = bounds[row, 0];
+        var range = (bounds[row, 1] - offset) / noSamples;
+        for (var j = 0; j < noSamples; j++) samples[j][i] = offset + (permutations[j] + random.NextDouble()) * range;
+      }
+      return samples;
+    }
+
+    protected override RealVector Create(IRandom random, IntValue length, DoubleMatrix bounds) {
+      if (design.Count == 0) design = new Queue<RealVector>(GetSamples(random, length.Value, bounds, DesignSize.ActualValue.Value));
+      return design.Dequeue();
+    }
+  }
+}
+
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/SamplingMethods/LatinHyperCubeDesignOLD.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/SamplingMethods/LatinHyperCubeDesignOLD.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/SamplingMethods/LatinHyperCubeDesignOLD.cs	(revision 15064)
@@ -0,0 +1,142 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+/*
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+// ReSharper disable once CheckNamespace
+namespace HeuristicLab.Algorithms.EGO {
+
+ [StorableClass]
+ [Item("LatinHyperCubeDesign", "A latin hypercube sampling strategy for real valued optimization")]
+ public class LatinHyperCubeDesign : ParameterizedNamedItem, IInitialSampling {
+
+   public const string DesigningAlgorithmParamterName = "DesignningAlgorithm";
+   public IValueParameter<IAlgorithm> DesigningAlgorithmParameter => Parameters[DesigningAlgorithmParamterName] as IValueParameter<IAlgorithm>;
+   private IAlgorithm DesigningAlgorithm => DesigningAlgorithmParameter.Value;
+
+   [StorableConstructor]
+   protected LatinHyperCubeDesign(bool deserializing) : base(deserializing) { }
+   protected LatinHyperCubeDesign(LatinHyperCubeDesign original, Cloner cloner) : base(original, cloner) { }
+   public LatinHyperCubeDesign() {
+     var es = new EvolutionStrategy.EvolutionStrategy {
+       PopulationSize = { Value = 50 },
+       Children = { Value = 100 },
+       MaximumGenerations = { Value = 300 }
+     };
+     Parameters.Add(new ValueParameter<IAlgorithm>(DesigningAlgorithmParamterName, "The Algorithm used for optimizing the Latin Hypercube (minimax) criterion.", es));
+   }
+   public override IDeepCloneable Clone(Cloner cloner) {
+     return new LatinHyperCubeDesign(this, cloner);
+   }
+
+   public RealVector[] GetSamples(int noSamples, RealVector[] existingSamples, RealVectorEncoding encoding, IRandom random) {
+     var lhsprob = new LHSProblem(noSamples, existingSamples, encoding);
+     DesigningAlgorithm.Problem = lhsprob;
+     EgoUtilities.SyncRunSubAlgorithm(DesigningAlgorithm, random.Next());
+     return lhsprob.BestSolution;
+   }
+ }
+
+ [StorableClass]
+ internal class LHSProblem : SingleObjectiveBasicProblem<RealVectorEncoding> {
+   [Storable]
+   private int NoVectors;
+   [Storable]
+   private int NoDimensions;
+   [Storable]
+   private RealVector[] ExistingSamples;
+
+   [Storable]
+   public double BestQuality = double.MinValue;
+   [Storable]
+   public RealVector[] BestSolution;
+
+   [StorableConstructor]
+   protected LHSProblem(bool deserializing) : base(deserializing) { }
+   protected LHSProblem(LHSProblem original, Cloner cloner) : base(original, cloner) {
+     NoDimensions = original.NoDimensions;
+     NoVectors = original.NoVectors;
+     ExistingSamples = original.ExistingSamples?.Select(cloner.Clone).ToArray();
+   }
+   public LHSProblem(int novectors, RealVector[] existingSamples, RealVectorEncoding encoding) {
+     NoVectors = novectors;
+     NoDimensions = encoding.Length;
+     ExistingSamples = existingSamples;
+     Encoding.Length = novectors * encoding.Length;
+     var b = new DoubleMatrix(Encoding.Length, 2);
+     for (int i = 0; i < novectors; i++) {
+       for (int j = 0; j < encoding.Length; j++) {
+         var k = j % encoding.Bounds.Rows;
+         b[i * encoding.Length + j, 0] = encoding.Bounds[k, 0];
+         b[i * encoding.Length + j, 1] = encoding.Bounds[k, 1];
+       }
+     }
+     Encoding.Bounds = b;
+
+   }
+   public override IDeepCloneable Clone(Cloner cloner) {
+     return new LHSProblem(this, cloner);
+   }
+
+   public override double Evaluate(Individual individual, IRandom random) {
+     return Enumerable.Range(0, NoVectors).Select(x => MinDistance(x, individual.RealVector())).Min();
+   }
+
+   //returns -1 if no distance can be calculated
+   private double MinDistance(int pointNumber, RealVector design) {
+     var min = double.MaxValue;
+     if (ExistingSamples != null && ExistingSamples.Length != 0) min = ExistingSamples.Select(x => Distance(x, ExtractPoint(pointNumber, design))).Min();
+     if (pointNumber == 0) return min;
+     var min2 = Enumerable.Range(0, pointNumber).Select(i => Distance(ExtractPoint(i, design), ExtractPoint(pointNumber, design))).Min();
+     return min < 0 ? min2 : Math.Min(min, min2);
+   }
+   private IEnumerable<double> ExtractPoint(int pointNumber, RealVector design) {
+     return design.Skip(NoDimensions * pointNumber).Take(NoDimensions);
+   }
+   private static double Distance(IEnumerable<double> a, IEnumerable<double> b) {
+     return a.Zip(b, (d, d1) => d - d1).Sum(d => d * d);
+   }
+
+   public override void Analyze(Individual[] individuals, double[] qualities, ResultCollection results, IRandom random) {
+     base.Analyze(individuals, qualities, results, random);
+     var i = qualities.ArgMin(x => x);
+     if (BestQuality > qualities[i]) return;
+     var r = individuals[i].RealVector();
+     BestSolution = Enumerable.Range(0, NoVectors).Select(x => new RealVector(ExtractPoint(x, r).ToArray())).ToArray();
+   }
+   public override bool Maximization => true;
+ }
+
+
+
+
+}
+*/
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/SamplingMethods/UniformRandomSampling.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/SamplingMethods/UniformRandomSampling.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/SamplingMethods/UniformRandomSampling.cs	(revision 15064)
@@ -34,6 +34,6 @@
     #region HL-Constructors, Serialization and Cloning 
     [StorableConstructor]
-    private UniformRandomSampling(bool deserializing) : base(deserializing) { }
-    private UniformRandomSampling(UniformRandomSampling original, Cloner cloner) : base(original, cloner) { }
+    protected UniformRandomSampling(bool deserializing) : base(deserializing) { }
+    protected UniformRandomSampling(UniformRandomSampling original, Cloner cloner) : base(original, cloner) { }
     public UniformRandomSampling() {
     }
